--TEST--
Turba_Driver::toHash() test.
--FILE--
<?php

require_once 'PEAR.php';
require_once 'Horde/iCalendar.php';
require dirname(__FILE__) . '/../Object.php';
require dirname(__FILE__) . '/../Driver.php';

$GLOBALS['tz']['Europe/Berlin'] = 'Europe/Berlin';

$vcard2 = '
BEGIN:VCARD
VERSION:2.1
FN;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
Jan Schneider=F6
EMAIL:jan@horde.org
NICKNAME:yunosh
TEL;HOME:+49 521 555123
TEL;WORK:+49 521 555456
TEL;CELL:+49 177 555123
TEL;FAX:+49 521 555789
TEL;PAGER:+49 123 555789
BDAY:1971-10-01
TITLE;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
Senior Developer (=E4=F6=FC)
ROLE;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
Developer (=E4=F6=FC)
NOTE;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
A German guy (=E4=F6=FC)
URL:http://janschneider.de
N;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
Schneider=F6;Jan;K.;Mr.;
ORG;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
Horde Project;=E4=F6=FC
ADR;HOME;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
;;Sch=F6nestr. 15;Bielefeld;;33604;
ADR;WORK;CHARSET=ISO-8859-1;ENCODING=QUOTED-PRINTABLE:=
;;H=FCbschestr. 19;K=F6ln;Allg=E4u;;D=E4nemark
TZ;VALUE=text:+02:00; Europe/Berlin
GEO:52.516276;13.377778
BODY:
END:VCARD
';

$vcard3 = '
BEGIN:VCARD
VERSION:3.0
FN:Jan Schneiderö
EMAIL:jan@horde.org
NICKNAME:yunosh
TEL;TYPE=HOME:+49 521 555123
TEL;TYPE=WORK:+49 521 555456
TEL;TYPE=CELL:+49 177 555123
TEL;TYPE=FAX:+49 521 555789
TEL;TYPE=PAGER:+49 123 555789
BDAY:1971-10-01
TITLE:Senior Developer (äöü)
ROLE:Developer (äöü)
NOTE:A German guy (äöü)
URL:http://janschneider.de
N:Schneiderö;Jan;K.;Mr.;
ORG:Horde Project;äöü
ADR;TYPE=HOME:;;Schönestr. 15;Bielefeld;;33604;;
ADR;TYPE=WORK:;;Hübschestr. 19;Köln;Allgäu;;Dänemark
TZ;VALUE=text:+02:00; Europe/Berlin
GEO:52.516276;13.377778
BODY:
END:VCARD
';

$driver = new Turba_Driver(array());
$iCal = new Horde_iCalendar();
$iCal->parsevCalendar($vcard2);
var_export($driver->toHash($iCal->getComponent(0)));
echo "\n";
$iCal->parsevCalendar($vcard3);
var_export($driver->toHash($iCal->getComponent(0)));

?>
--EXPECT--
array (
  'email' => 'jan@horde.org',
  'nickname' => 'yunosh',
  'alias' => 'yunosh',
  'homePhone' => '+49 521 555123',
  'workPhone' => '+49 521 555456',
  'cellPhone' => '+49 177 555123',
  'fax' => '+49 521 555789',
  'pager' => '+49 123 555789',
  'birthday' => '1971-10-01',
  'title' => 'Senior Developer ()',
  'role' => 'Developer ()',
  'notes' => 'A German guy ()',
  'website' => 'http://janschneider.de',
  'lastname' => 'Schneider',
  'firstname' => 'Jan',
  'middlenames' => 'K.',
  'namePrefix' => 'Mr.',
  'company' => 'Horde Project',
  'department' => '',
  'homeAddress' => 'Schnestr. 15
Bielefeld 33604',
  'homeStreet' => 'Schnestr. 15',
  'homeCity' => 'Bielefeld',
  'homePostalCode' => '33604',
  'workAddress' => 'Hbschestr. 19
Kln, Allgu
Dnemark',
  'workStreet' => 'Hbschestr. 19',
  'workCity' => 'Kln',
  'workProvince' => 'Allgu',
  'workCountry' => 'Dnemark',
  'timezone' => 'Europe/Berlin',
  'latitude' => 52.516276,
  'longitude' => 13.377778,
)
array (
  'email' => 'jan@horde.org',
  'nickname' => 'yunosh',
  'alias' => 'yunosh',
  'homePhone' => '+49 521 555123',
  'workPhone' => '+49 521 555456',
  'cellPhone' => '+49 177 555123',
  'fax' => '+49 521 555789',
  'pager' => '+49 123 555789',
  'birthday' => '1971-10-01',
  'title' => 'Senior Developer ()',
  'role' => 'Developer ()',
  'notes' => 'A German guy ()',
  'website' => 'http://janschneider.de',
  'lastname' => 'Schneider',
  'firstname' => 'Jan',
  'middlenames' => 'K.',
  'namePrefix' => 'Mr.',
  'company' => 'Horde Project',
  'department' => '',
  'homeAddress' => 'Schnestr. 15
Bielefeld 33604',
  'homeStreet' => 'Schnestr. 15',
  'homeCity' => 'Bielefeld',
  'homePostalCode' => '33604',
  'workAddress' => 'Hbschestr. 19
Kln, Allgu
Dnemark',
  'workStreet' => 'Hbschestr. 19',
  'workCity' => 'Kln',
  'workProvince' => 'Allgu',
  'workCountry' => 'Dnemark',
  'timezone' => 'Europe/Berlin',
  'latitude' => 52.516276,
  'longitude' => 13.377778,
)
